export declare const CLEARINGHOUSE_ABI: readonly [{
    readonly anonymous: false;
    readonly inputs: readonly [{
        readonly indexed: false;
        readonly internalType: "address";
        readonly name: "endpoint";
        readonly type: "address";
    }, {
        readonly indexed: false;
        readonly internalType: "address";
        readonly name: "quote";
        readonly type: "address";
    }];
    readonly name: "ClearinghouseInitialized";
    readonly type: "event";
}, {
    readonly anonymous: false;
    readonly inputs: readonly [{
        readonly indexed: true;
        readonly internalType: "bytes32";
        readonly name: "liquidatorSubaccount";
        readonly type: "bytes32";
    }, {
        readonly indexed: true;
        readonly internalType: "bytes32";
        readonly name: "liquidateeSubaccount";
        readonly type: "bytes32";
    }, {
        readonly indexed: false;
        readonly internalType: "uint32";
        readonly name: "productId";
        readonly type: "uint32";
    }, {
        readonly indexed: false;
        readonly internalType: "bool";
        readonly name: "isEncodedSpread";
        readonly type: "bool";
    }, {
        readonly indexed: false;
        readonly internalType: "int128";
        readonly name: "amount";
        readonly type: "int128";
    }, {
        readonly indexed: false;
        readonly internalType: "int128";
        readonly name: "amountQuote";
        readonly type: "int128";
    }];
    readonly name: "Liquidation";
    readonly type: "event";
}, {
    readonly anonymous: false;
    readonly inputs: readonly [{
        readonly indexed: false;
        readonly internalType: "int128";
        readonly name: "amount";
        readonly type: "int128";
    }, {
        readonly indexed: true;
        readonly internalType: "bytes32";
        readonly name: "subaccount";
        readonly type: "bytes32";
    }, {
        readonly indexed: false;
        readonly internalType: "uint32";
        readonly name: "productId";
        readonly type: "uint32";
    }];
    readonly name: "ModifyCollateral";
    readonly type: "event";
}, {
    readonly inputs: readonly [{
        readonly internalType: "address";
        readonly name: "engine";
        readonly type: "address";
    }, {
        readonly internalType: "address";
        readonly name: "offchainExchange";
        readonly type: "address";
    }, {
        readonly internalType: "enum IProductEngine.EngineType";
        readonly name: "engineType";
        readonly type: "uint8";
    }];
    readonly name: "addEngine";
    readonly outputs: readonly [];
    readonly stateMutability: "nonpayable";
    readonly type: "function";
}, {
    readonly inputs: readonly [{
        readonly components: readonly [{
            readonly internalType: "bytes32";
            readonly name: "sender";
            readonly type: "bytes32";
        }, {
            readonly internalType: "uint32";
            readonly name: "productId";
            readonly type: "uint32";
        }, {
            readonly internalType: "uint128";
            readonly name: "amount";
            readonly type: "uint128";
        }, {
            readonly internalType: "uint64";
            readonly name: "nonce";
            readonly type: "uint64";
        }];
        readonly internalType: "struct IEndpoint.BurnLp";
        readonly name: "tx";
        readonly type: "tuple";
    }];
    readonly name: "burnLp";
    readonly outputs: readonly [];
    readonly stateMutability: "nonpayable";
    readonly type: "function";
}, {
    readonly inputs: readonly [{
        readonly components: readonly [{
            readonly internalType: "bytes32";
            readonly name: "sender";
            readonly type: "bytes32";
        }, {
            readonly internalType: "uint32";
            readonly name: "productId";
            readonly type: "uint32";
        }, {
            readonly internalType: "uint128";
            readonly name: "amount";
            readonly type: "uint128";
        }, {
            readonly internalType: "bytes32";
            readonly name: "recipient";
            readonly type: "bytes32";
        }];
        readonly internalType: "struct IEndpoint.BurnLpAndTransfer";
        readonly name: "txn";
        readonly type: "tuple";
    }];
    readonly name: "burnLpAndTransfer";
    readonly outputs: readonly [];
    readonly stateMutability: "nonpayable";
    readonly type: "function";
}, {
    readonly inputs: readonly [{
        readonly components: readonly [{
            readonly internalType: "bytes32";
            readonly name: "subaccount";
            readonly type: "bytes32";
        }];
        readonly internalType: "struct IEndpoint.ClaimSequencerFees";
        readonly name: "tx";
        readonly type: "tuple";
    }, {
        readonly internalType: "int128[]";
        readonly name: "fees";
        readonly type: "int128[]";
    }];
    readonly name: "claimSequencerFees";
    readonly outputs: readonly [];
    readonly stateMutability: "nonpayable";
    readonly type: "function";
}, {
    readonly inputs: readonly [{
        readonly components: readonly [{
            readonly internalType: "bytes32";
            readonly name: "sender";
            readonly type: "bytes32";
        }, {
            readonly internalType: "uint32";
            readonly name: "productId";
            readonly type: "uint32";
        }, {
            readonly internalType: "uint128";
            readonly name: "amount";
            readonly type: "uint128";
        }];
        readonly internalType: "struct IEndpoint.DepositCollateral";
        readonly name: "tx";
        readonly type: "tuple";
    }];
    readonly name: "depositCollateral";
    readonly outputs: readonly [];
    readonly stateMutability: "nonpayable";
    readonly type: "function";
}, {
    readonly inputs: readonly [{
        readonly components: readonly [{
            readonly internalType: "uint128";
            readonly name: "amount";
            readonly type: "uint128";
        }];
        readonly internalType: "struct IEndpoint.DepositInsurance";
        readonly name: "tx";
        readonly type: "tuple";
    }];
    readonly name: "depositInsurance";
    readonly outputs: readonly [];
    readonly stateMutability: "nonpayable";
    readonly type: "function";
}, {
    readonly inputs: readonly [];
    readonly name: "getClearinghouseLiq";
    readonly outputs: readonly [{
        readonly internalType: "address";
        readonly name: "";
        readonly type: "address";
    }];
    readonly stateMutability: "view";
    readonly type: "function";
}, {
    readonly inputs: readonly [];
    readonly name: "getEndpoint";
    readonly outputs: readonly [{
        readonly internalType: "address";
        readonly name: "endpoint";
        readonly type: "address";
    }];
    readonly stateMutability: "view";
    readonly type: "function";
}, {
    readonly inputs: readonly [{
        readonly internalType: "uint32";
        readonly name: "productId";
        readonly type: "uint32";
    }];
    readonly name: "getEngineByProduct";
    readonly outputs: readonly [{
        readonly internalType: "address";
        readonly name: "";
        readonly type: "address";
    }];
    readonly stateMutability: "view";
    readonly type: "function";
}, {
    readonly inputs: readonly [{
        readonly internalType: "enum IProductEngine.EngineType";
        readonly name: "engineType";
        readonly type: "uint8";
    }];
    readonly name: "getEngineByType";
    readonly outputs: readonly [{
        readonly internalType: "address";
        readonly name: "";
        readonly type: "address";
    }];
    readonly stateMutability: "view";
    readonly type: "function";
}, {
    readonly inputs: readonly [{
        readonly internalType: "bytes32";
        readonly name: "subaccount";
        readonly type: "bytes32";
    }, {
        readonly internalType: "enum IProductEngine.HealthType";
        readonly name: "healthType";
        readonly type: "uint8";
    }];
    readonly name: "getHealth";
    readonly outputs: readonly [{
        readonly internalType: "int128";
        readonly name: "";
        readonly type: "int128";
    }];
    readonly stateMutability: "view";
    readonly type: "function";
}, {
    readonly inputs: readonly [];
    readonly name: "getInsurance";
    readonly outputs: readonly [{
        readonly internalType: "int128";
        readonly name: "";
        readonly type: "int128";
    }];
    readonly stateMutability: "view";
    readonly type: "function";
}, {
    readonly inputs: readonly [];
    readonly name: "getQuote";
    readonly outputs: readonly [{
        readonly internalType: "address";
        readonly name: "";
        readonly type: "address";
    }];
    readonly stateMutability: "view";
    readonly type: "function";
}, {
    readonly inputs: readonly [];
    readonly name: "getSpreads";
    readonly outputs: readonly [{
        readonly internalType: "uint256";
        readonly name: "";
        readonly type: "uint256";
    }];
    readonly stateMutability: "view";
    readonly type: "function";
}, {
    readonly inputs: readonly [];
    readonly name: "getVersion";
    readonly outputs: readonly [{
        readonly internalType: "uint64";
        readonly name: "";
        readonly type: "uint64";
    }];
    readonly stateMutability: "view";
    readonly type: "function";
}, {
    readonly inputs: readonly [{
        readonly components: readonly [{
            readonly internalType: "bytes32";
            readonly name: "sender";
            readonly type: "bytes32";
        }, {
            readonly internalType: "bytes32";
            readonly name: "liquidatee";
            readonly type: "bytes32";
        }, {
            readonly internalType: "uint32";
            readonly name: "productId";
            readonly type: "uint32";
        }, {
            readonly internalType: "bool";
            readonly name: "isEncodedSpread";
            readonly type: "bool";
        }, {
            readonly internalType: "int128";
            readonly name: "amount";
            readonly type: "int128";
        }, {
            readonly internalType: "uint64";
            readonly name: "nonce";
            readonly type: "uint64";
        }];
        readonly internalType: "struct IEndpoint.LiquidateSubaccount";
        readonly name: "tx";
        readonly type: "tuple";
    }];
    readonly name: "liquidateSubaccount";
    readonly outputs: readonly [];
    readonly stateMutability: "nonpayable";
    readonly type: "function";
}, {
    readonly inputs: readonly [{
        readonly components: readonly [{
            readonly internalType: "bytes32";
            readonly name: "sender";
            readonly type: "bytes32";
        }, {
            readonly internalType: "uint32";
            readonly name: "productId";
            readonly type: "uint32";
        }, {
            readonly internalType: "uint128";
            readonly name: "amountBase";
            readonly type: "uint128";
        }, {
            readonly internalType: "uint128";
            readonly name: "quoteAmountLow";
            readonly type: "uint128";
        }, {
            readonly internalType: "uint128";
            readonly name: "quoteAmountHigh";
            readonly type: "uint128";
        }, {
            readonly internalType: "uint64";
            readonly name: "nonce";
            readonly type: "uint64";
        }];
        readonly internalType: "struct IEndpoint.MintLp";
        readonly name: "tx";
        readonly type: "tuple";
    }];
    readonly name: "mintLp";
    readonly outputs: readonly [];
    readonly stateMutability: "nonpayable";
    readonly type: "function";
}, {
    readonly inputs: readonly [{
        readonly internalType: "uint32";
        readonly name: "productId";
        readonly type: "uint32";
    }];
    readonly name: "registerProduct";
    readonly outputs: readonly [];
    readonly stateMutability: "nonpayable";
    readonly type: "function";
}, {
    readonly inputs: readonly [{
        readonly components: readonly [{
            readonly internalType: "bytes32[]";
            readonly name: "subaccounts";
            readonly type: "bytes32[]";
        }, {
            readonly internalType: "uint256[]";
            readonly name: "productIds";
            readonly type: "uint256[]";
        }];
        readonly internalType: "struct IEndpoint.SettlePnl";
        readonly name: "tx";
        readonly type: "tuple";
    }];
    readonly name: "settlePnl";
    readonly outputs: readonly [];
    readonly stateMutability: "nonpayable";
    readonly type: "function";
}, {
    readonly inputs: readonly [{
        readonly components: readonly [{
            readonly internalType: "bytes32";
            readonly name: "sender";
            readonly type: "bytes32";
        }, {
            readonly internalType: "bytes32";
            readonly name: "recipient";
            readonly type: "bytes32";
        }, {
            readonly internalType: "uint128";
            readonly name: "amount";
            readonly type: "uint128";
        }, {
            readonly internalType: "uint64";
            readonly name: "nonce";
            readonly type: "uint64";
        }];
        readonly internalType: "struct IEndpoint.TransferQuote";
        readonly name: "tx";
        readonly type: "tuple";
    }];
    readonly name: "transferQuote";
    readonly outputs: readonly [];
    readonly stateMutability: "nonpayable";
    readonly type: "function";
}, {
    readonly inputs: readonly [{
        readonly internalType: "address";
        readonly name: "_clearinghouseLiq";
        readonly type: "address";
    }];
    readonly name: "upgradeClearinghouseLiq";
    readonly outputs: readonly [];
    readonly stateMutability: "nonpayable";
    readonly type: "function";
}, {
    readonly inputs: readonly [{
        readonly internalType: "bytes32";
        readonly name: "sender";
        readonly type: "bytes32";
    }, {
        readonly internalType: "uint32";
        readonly name: "productId";
        readonly type: "uint32";
    }, {
        readonly internalType: "uint128";
        readonly name: "amount";
        readonly type: "uint128";
    }, {
        readonly internalType: "address";
        readonly name: "sendTo";
        readonly type: "address";
    }];
    readonly name: "withdrawCollateral";
    readonly outputs: readonly [];
    readonly stateMutability: "nonpayable";
    readonly type: "function";
}];
//# sourceMappingURL=Clearinghouse.d.ts.map