export declare const ENDPOINT_ABI: readonly [{
    readonly anonymous: false;
    readonly inputs: readonly [{
        readonly indexed: false;
        readonly internalType: "uint8";
        readonly name: "version";
        readonly type: "uint8";
    }];
    readonly name: "Initialized";
    readonly type: "event";
}, {
    readonly anonymous: false;
    readonly inputs: readonly [{
        readonly indexed: true;
        readonly internalType: "address";
        readonly name: "previousOwner";
        readonly type: "address";
    }, {
        readonly indexed: true;
        readonly internalType: "address";
        readonly name: "newOwner";
        readonly type: "address";
    }];
    readonly name: "OwnershipTransferred";
    readonly type: "event";
}, {
    readonly anonymous: false;
    readonly inputs: readonly [];
    readonly name: "SubmitTransactions";
    readonly type: "event";
}, {
    readonly inputs: readonly [];
    readonly name: "clearinghouse";
    readonly outputs: readonly [{
        readonly internalType: "contract IClearinghouse";
        readonly name: "";
        readonly type: "address";
    }];
    readonly stateMutability: "view";
    readonly type: "function";
}, {
    readonly inputs: readonly [{
        readonly internalType: "bytes12";
        readonly name: "subaccountName";
        readonly type: "bytes12";
    }, {
        readonly internalType: "uint32";
        readonly name: "productId";
        readonly type: "uint32";
    }, {
        readonly internalType: "uint128";
        readonly name: "amount";
        readonly type: "uint128";
    }];
    readonly name: "depositCollateral";
    readonly outputs: readonly [];
    readonly stateMutability: "nonpayable";
    readonly type: "function";
}, {
    readonly inputs: readonly [{
        readonly internalType: "bytes32";
        readonly name: "subaccount";
        readonly type: "bytes32";
    }, {
        readonly internalType: "uint32";
        readonly name: "productId";
        readonly type: "uint32";
    }, {
        readonly internalType: "uint128";
        readonly name: "amount";
        readonly type: "uint128";
    }, {
        readonly internalType: "string";
        readonly name: "referralCode";
        readonly type: "string";
    }];
    readonly name: "depositCollateralWithReferral";
    readonly outputs: readonly [];
    readonly stateMutability: "nonpayable";
    readonly type: "function";
}, {
    readonly inputs: readonly [{
        readonly internalType: "bytes12";
        readonly name: "subaccountName";
        readonly type: "bytes12";
    }, {
        readonly internalType: "uint32";
        readonly name: "productId";
        readonly type: "uint32";
    }, {
        readonly internalType: "uint128";
        readonly name: "amount";
        readonly type: "uint128";
    }, {
        readonly internalType: "string";
        readonly name: "referralCode";
        readonly type: "string";
    }];
    readonly name: "depositCollateralWithReferral";
    readonly outputs: readonly [];
    readonly stateMutability: "nonpayable";
    readonly type: "function";
}, {
    readonly inputs: readonly [{
        readonly internalType: "uint32";
        readonly name: "count";
        readonly type: "uint32";
    }];
    readonly name: "executeSlowModeTransactions";
    readonly outputs: readonly [];
    readonly stateMutability: "nonpayable";
    readonly type: "function";
}, {
    readonly inputs: readonly [{
        readonly internalType: "uint32";
        readonly name: "productId";
        readonly type: "uint32";
    }];
    readonly name: "getBook";
    readonly outputs: readonly [{
        readonly internalType: "address";
        readonly name: "";
        readonly type: "address";
    }];
    readonly stateMutability: "view";
    readonly type: "function";
}, {
    readonly inputs: readonly [{
        readonly internalType: "address";
        readonly name: "sender";
        readonly type: "address";
    }];
    readonly name: "getNonce";
    readonly outputs: readonly [{
        readonly internalType: "uint64";
        readonly name: "";
        readonly type: "uint64";
    }];
    readonly stateMutability: "view";
    readonly type: "function";
}, {
    readonly inputs: readonly [{
        readonly internalType: "uint32";
        readonly name: "productId";
        readonly type: "uint32";
    }];
    readonly name: "getPriceX18";
    readonly outputs: readonly [{
        readonly internalType: "int128";
        readonly name: "priceX18";
        readonly type: "int128";
    }];
    readonly stateMutability: "view";
    readonly type: "function";
}, {
    readonly inputs: readonly [{
        readonly internalType: "uint32";
        readonly name: "healthGroup";
        readonly type: "uint32";
    }];
    readonly name: "getPricesX18";
    readonly outputs: readonly [{
        readonly components: readonly [{
            readonly internalType: "int128";
            readonly name: "spotPriceX18";
            readonly type: "int128";
        }, {
            readonly internalType: "int128";
            readonly name: "perpPriceX18";
            readonly type: "int128";
        }];
        readonly internalType: "struct IEndpoint.Prices";
        readonly name: "";
        readonly type: "tuple";
    }];
    readonly stateMutability: "view";
    readonly type: "function";
}, {
    readonly inputs: readonly [];
    readonly name: "getSequencer";
    readonly outputs: readonly [{
        readonly internalType: "address";
        readonly name: "";
        readonly type: "address";
    }];
    readonly stateMutability: "view";
    readonly type: "function";
}, {
    readonly inputs: readonly [{
        readonly internalType: "bytes32";
        readonly name: "subaccount";
        readonly type: "bytes32";
    }];
    readonly name: "getSubaccountId";
    readonly outputs: readonly [{
        readonly internalType: "uint64";
        readonly name: "";
        readonly type: "uint64";
    }];
    readonly stateMutability: "view";
    readonly type: "function";
}, {
    readonly inputs: readonly [];
    readonly name: "getTime";
    readonly outputs: readonly [{
        readonly internalType: "uint128";
        readonly name: "";
        readonly type: "uint128";
    }];
    readonly stateMutability: "view";
    readonly type: "function";
}, {
    readonly inputs: readonly [];
    readonly name: "getVersion";
    readonly outputs: readonly [{
        readonly internalType: "uint64";
        readonly name: "";
        readonly type: "uint64";
    }];
    readonly stateMutability: "pure";
    readonly type: "function";
}, {
    readonly inputs: readonly [{
        readonly internalType: "address";
        readonly name: "_sanctions";
        readonly type: "address";
    }, {
        readonly internalType: "address";
        readonly name: "_sequencer";
        readonly type: "address";
    }, {
        readonly internalType: "contract IClearinghouse";
        readonly name: "_clearinghouse";
        readonly type: "address";
    }, {
        readonly internalType: "uint64";
        readonly name: "slowModeTimeout";
        readonly type: "uint64";
    }, {
        readonly internalType: "uint128";
        readonly name: "_time";
        readonly type: "uint128";
    }, {
        readonly internalType: "int128[]";
        readonly name: "_prices";
        readonly type: "int128[]";
    }];
    readonly name: "initialize";
    readonly outputs: readonly [];
    readonly stateMutability: "nonpayable";
    readonly type: "function";
}, {
    readonly inputs: readonly [];
    readonly name: "nSubmissions";
    readonly outputs: readonly [{
        readonly internalType: "uint64";
        readonly name: "";
        readonly type: "uint64";
    }];
    readonly stateMutability: "view";
    readonly type: "function";
}, {
    readonly inputs: readonly [];
    readonly name: "owner";
    readonly outputs: readonly [{
        readonly internalType: "address";
        readonly name: "";
        readonly type: "address";
    }];
    readonly stateMutability: "view";
    readonly type: "function";
}, {
    readonly inputs: readonly [{
        readonly internalType: "address";
        readonly name: "sender";
        readonly type: "address";
    }, {
        readonly internalType: "bytes";
        readonly name: "transaction";
        readonly type: "bytes";
    }];
    readonly name: "processSlowModeTransaction";
    readonly outputs: readonly [];
    readonly stateMutability: "nonpayable";
    readonly type: "function";
}, {
    readonly inputs: readonly [{
        readonly internalType: "address";
        readonly name: "";
        readonly type: "address";
    }];
    readonly name: "referralCodes";
    readonly outputs: readonly [{
        readonly internalType: "string";
        readonly name: "";
        readonly type: "string";
    }];
    readonly stateMutability: "view";
    readonly type: "function";
}, {
    readonly inputs: readonly [{
        readonly internalType: "address";
        readonly name: "wallet";
        readonly type: "address";
    }, {
        readonly internalType: "bool";
        readonly name: "transferable";
        readonly type: "bool";
    }];
    readonly name: "registerTransferableWallet";
    readonly outputs: readonly [];
    readonly stateMutability: "nonpayable";
    readonly type: "function";
}, {
    readonly inputs: readonly [];
    readonly name: "renounceOwnership";
    readonly outputs: readonly [];
    readonly stateMutability: "nonpayable";
    readonly type: "function";
}, {
    readonly inputs: readonly [{
        readonly internalType: "bytes32";
        readonly name: "subaccount";
        readonly type: "bytes32";
    }];
    readonly name: "requireSubaccount";
    readonly outputs: readonly [];
    readonly stateMutability: "view";
    readonly type: "function";
}, {
    readonly inputs: readonly [{
        readonly internalType: "uint32";
        readonly name: "";
        readonly type: "uint32";
    }];
    readonly name: "sequencerFee";
    readonly outputs: readonly [{
        readonly internalType: "int128";
        readonly name: "";
        readonly type: "int128";
    }];
    readonly stateMutability: "view";
    readonly type: "function";
}, {
    readonly inputs: readonly [];
    readonly name: "sequencerFees";
    readonly outputs: readonly [{
        readonly internalType: "int128";
        readonly name: "";
        readonly type: "int128";
    }];
    readonly stateMutability: "view";
    readonly type: "function";
}, {
    readonly inputs: readonly [{
        readonly internalType: "uint32";
        readonly name: "productId";
        readonly type: "uint32";
    }, {
        readonly internalType: "address";
        readonly name: "book";
        readonly type: "address";
    }];
    readonly name: "setBook";
    readonly outputs: readonly [];
    readonly stateMutability: "nonpayable";
    readonly type: "function";
}, {
    readonly inputs: readonly [{
        readonly internalType: "address";
        readonly name: "_sequencer";
        readonly type: "address";
    }];
    readonly name: "setSequencer";
    readonly outputs: readonly [];
    readonly stateMutability: "nonpayable";
    readonly type: "function";
}, {
    readonly inputs: readonly [];
    readonly name: "slowModeConfig";
    readonly outputs: readonly [{
        readonly internalType: "uint64";
        readonly name: "timeout";
        readonly type: "uint64";
    }, {
        readonly internalType: "uint64";
        readonly name: "txCount";
        readonly type: "uint64";
    }, {
        readonly internalType: "uint64";
        readonly name: "txUpTo";
        readonly type: "uint64";
    }];
    readonly stateMutability: "view";
    readonly type: "function";
}, {
    readonly inputs: readonly [{
        readonly internalType: "uint64";
        readonly name: "";
        readonly type: "uint64";
    }];
    readonly name: "slowModeTxs";
    readonly outputs: readonly [{
        readonly internalType: "uint64";
        readonly name: "executableAt";
        readonly type: "uint64";
    }, {
        readonly internalType: "address";
        readonly name: "sender";
        readonly type: "address";
    }, {
        readonly internalType: "bytes";
        readonly name: "tx";
        readonly type: "bytes";
    }];
    readonly stateMutability: "view";
    readonly type: "function";
}, {
    readonly inputs: readonly [{
        readonly internalType: "bytes";
        readonly name: "transaction";
        readonly type: "bytes";
    }];
    readonly name: "submitSlowModeTransaction";
    readonly outputs: readonly [];
    readonly stateMutability: "nonpayable";
    readonly type: "function";
}, {
    readonly inputs: readonly [{
        readonly internalType: "bytes[]";
        readonly name: "transactions";
        readonly type: "bytes[]";
    }];
    readonly name: "submitTransactions";
    readonly outputs: readonly [];
    readonly stateMutability: "nonpayable";
    readonly type: "function";
}, {
    readonly inputs: readonly [{
        readonly internalType: "uint64";
        readonly name: "idx";
        readonly type: "uint64";
    }, {
        readonly internalType: "bytes[]";
        readonly name: "transactions";
        readonly type: "bytes[]";
    }];
    readonly name: "submitTransactionsChecked";
    readonly outputs: readonly [];
    readonly stateMutability: "nonpayable";
    readonly type: "function";
}, {
    readonly inputs: readonly [{
        readonly internalType: "uint64";
        readonly name: "idx";
        readonly type: "uint64";
    }, {
        readonly internalType: "bytes[]";
        readonly name: "transactions";
        readonly type: "bytes[]";
    }, {
        readonly internalType: "uint256";
        readonly name: "gasLimit";
        readonly type: "uint256";
    }];
    readonly name: "submitTransactionsCheckedWithGasLimit";
    readonly outputs: readonly [{
        readonly internalType: "uint64";
        readonly name: "";
        readonly type: "uint64";
    }, {
        readonly internalType: "uint256";
        readonly name: "";
        readonly type: "uint256";
    }];
    readonly stateMutability: "nonpayable";
    readonly type: "function";
}, {
    readonly inputs: readonly [{
        readonly internalType: "address";
        readonly name: "newOwner";
        readonly type: "address";
    }];
    readonly name: "transferOwnership";
    readonly outputs: readonly [];
    readonly stateMutability: "nonpayable";
    readonly type: "function";
}];
//# sourceMappingURL=Endpoint.d.ts.map