import { getValidatedAddress } from '@vertex-protocol/utils';
import ArbitrumOneCoreDeployment from './core/deployment.arbitrumOne.json';
import ArbitrumSepoliaCoreDeployment from './core/deployment.arbitrumSepolia.json';
import LocalCoreDeployment from './core/deployment.localhost.json';
/**
 * Known deployment addresses for the Vertex contracts
 */
export const VERTEX_DEPLOYMENTS = {
    arbitrumTestnet: validateDeployment({
        ...ArbitrumSepoliaCoreDeployment,
    }),
    arbitrum: validateDeployment({
        ...ArbitrumOneCoreDeployment,
    }),
    local: validateDeployment({
        ...LocalCoreDeployment,
    }),
};
function validateDeployment(deployment) {
    return {
        clearinghouse: getValidatedAddress(deployment.clearinghouse),
        endpoint: getValidatedAddress(deployment.endpoint),
        perpEngine: getValidatedAddress(deployment.perpEngine),
        querier: getValidatedAddress(deployment.querier),
        spotEngine: getValidatedAddress(deployment.spotEngine),
        withdrawPool: getValidatedAddress(deployment.withdrawPool),
    };
}
//# sourceMappingURL=index.js.map