/**
 * Representation of the ProductEngineType enum used within the contract
 * Enums do not get reflected in the ABI, so this must be manually defined
 */
export var ProductEngineType;
(function (ProductEngineType) {
    ProductEngineType[ProductEngineType["SPOT"] = 0] = "SPOT";
    ProductEngineType[ProductEngineType["PERP"] = 1] = "PERP";
})(ProductEngineType || (ProductEngineType = {}));
/**
 * Maps a raw ProductEngineType enum value to the proper type
 * @param val
 */
export function toProductEngineType(val) {
    switch (val) {
        case 0:
            return ProductEngineType.SPOT;
        case 1:
            return ProductEngineType.PERP;
        default:
            throw new Error(`Unknown product engine type: ${val}`);
    }
}
//# sourceMappingURL=productTypes.js.map