import { VertexAbis, VertexContractName } from '../vertexAbis';
import { WriteableContractInstance } from './viemTypes';
/**
 * Encapsulates the set of Vertex contracts required for querying and executing, assumes that a wallet client is connected
 */
export type VertexContracts = {
    [name in VertexContractName]: WriteableContractInstance<VertexAbis[name]>;
};
export type WithContracts<T> = T & VertexContracts;
export type WithContract<TContractName extends keyof VertexContracts, T> = T & Pick<VertexContracts, TContractName>;
//# sourceMappingURL=vertexContractTypes.d.ts.map