import { SignableRequestTypeToEIP712Values } from './eip712ValueTypes';
import { SignableRequestType, SignableRequestTypeToParams } from './signableRequestType';
/**
 * Returns the EIP712 compatible values for signing.
 *
 * Note: We use the string representation of bigint to be compatible with JSON.stringify
 *
 * @param requestType
 * @param params
 */
export declare function getVertexEIP712Values<TReqType extends SignableRequestType>(requestType: TReqType, params: SignableRequestTypeToParams[TReqType]): SignableRequestTypeToEIP712Values[TReqType];
//# sourceMappingURL=getVertexEIP712Values.d.ts.map