import { BigDecimalish } from '@vertex-protocol/utils';
import { Address } from 'viem';
import { Subaccount } from '../common';
export interface SignedTx<TBaseTx> {
    tx: TBaseTx;
    signature: string;
}
export interface SignedEIP712OrderParams {
    order: EIP712OrderParams;
    signature: string;
}
export interface EIP712WithdrawCollateralParams extends Subaccount {
    productId: number;
    amount: BigDecimalish;
    nonce: string;
}
export interface EIP712MintLpParams extends Subaccount {
    productId: number;
    amountBase: BigDecimalish;
    quoteAmountLow: BigDecimalish;
    quoteAmountHigh: BigDecimalish;
    nonce: string;
}
export interface EIP712BurnLpParams extends Subaccount {
    productId: number;
    amount: BigDecimalish;
    nonce: string;
}
export interface EIP712LiquidateSubaccountParams extends Subaccount {
    liquidateeOwner: string;
    liquidateeName: string;
    mode: number;
    healthGroup: BigDecimalish;
    amount: BigDecimalish;
    nonce: string;
}
export interface EIP712OrderParams extends Subaccount {
    expiration: BigDecimalish;
    price: BigDecimalish;
    amount: BigDecimalish;
    nonce: string;
}
export interface EIP712IsolatedOrderParams extends EIP712OrderParams {
    margin: BigDecimalish;
}
export interface EIP712ListTriggerOrdersParams extends Subaccount {
    recvTime: BigDecimalish;
}
export interface EIP712CancelOrdersParams extends Subaccount {
    productIds: number[];
    digests: string[];
    nonce: string;
}
export interface EIP712CancelProductOrdersParams extends Subaccount {
    productIds: number[];
    nonce: string;
}
export interface EIP712LinkSignerParams extends Subaccount {
    signer: Address;
    nonce: string;
}
export interface EIP712TransferQuoteParams extends Subaccount {
    recipientSubaccountName: string;
    amount: BigDecimalish;
    nonce: string;
}
export interface EIP712LeaderboardAuthenticationParams extends Subaccount {
    expiration: BigDecimalish;
}
export interface EIP712MintVlpParams extends Subaccount {
    quoteAmount: BigDecimalish;
    nonce: string;
}
export interface EIP712BurnVlpParams extends Subaccount {
    vlpAmount: BigDecimalish;
    nonce: string;
}
//# sourceMappingURL=signatureParamTypes.d.ts.map