import { mapContractPerpProduct, mapContractSpotProduct } from './utils';
/**
 * Return all products registered with the clearinghouse. Calls querier internally.
 */
export async function getAllProducts({ querier, }) {
    const contractData = await querier.read.getAllProducts();
    const products = [];
    contractData.spotProducts.forEach((productInfo) => {
        products.push(mapContractSpotProduct(productInfo));
    });
    contractData.perpProducts.forEach((productInfo) => {
        products.push(mapContractPerpProduct(productInfo));
    });
    return products;
}
//# sourceMappingURL=getAllProducts.js.map