import { BalanceWithProduct, HealthStatusByType, Subaccount, WithContract } from '../common';
/**
 * Encapsulates health for an account or an account balance
 */
export type GetSubaccountSummaryParams = Subaccount;
export interface SubaccountSummaryResponse {
    exists: boolean;
    balances: BalanceWithProduct[];
    health: HealthStatusByType;
}
/**
 * Returns a comprehensive summary for a subaaccount, including its balances and health
 *
 * {@label CONTRACTS}
 */
export declare function getSubaccountSummary({ subaccountOwner, subaccountName, querier, }: WithContract<'querier', GetSubaccountSummaryParams>): Promise<SubaccountSummaryResponse>;
//# sourceMappingURL=getSubaccountSummary.d.ts.map