import { BigDecimal } from '@vertex-protocol/utils';
import { BalanceWithProduct, PerpBalanceWithProduct, Product, SpotBalanceWithProduct } from '../common';
/**
 * Calculates the quote value of a spot balance, in terms of quote units
 *
 * @param balanceWithProduct
 */
export declare function calcSpotBalanceValue(balanceWithProduct: SpotBalanceWithProduct): BigDecimal;
/**
 * Calculates the notional value of a perp balance, in terms of quote units
 *
 * @param balanceWithProduct
 */
export declare function calcPerpBalanceNotionalValue(balanceWithProduct: PerpBalanceWithProduct): BigDecimal;
/**
 * Calculates the true quote value of a perp balance, which is the same as its unrealized pnl / unsettled quote, in terms of quote units
 *
 * @param balanceWithProduct
 */
export declare function calcPerpBalanceValue(balanceWithProduct: PerpBalanceWithProduct): BigDecimal;
/**
 * Calculates the implied value of an LP balance, in terms of quote units
 *
 * @param balanceWithProduct
 */
export declare function calcLpBalanceValue(balanceWithProduct: BalanceWithProduct): BigDecimal;
/**
 * Calculates the implied value of an LP token, in terms of quote units
 *
 * @param product
 */
export declare function calcLpTokenValue(product: Product): BigDecimal;
//# sourceMappingURL=balanceValue.d.ts.map