import { Subaccount, WalletClientWithAccount } from '../common';
interface Params extends Subaccount {
    walletClient: WalletClientWithAccount;
    chainId: number;
    endpointAddress: string;
}
/**
 * Deterministically creates a new private key from a predetermined EIP712 message. This is used to
 * reliably create an authorized signer delegate for the subaccount across different clients. Used on the FE in order
 * to have a consistent private key for the subaccount linked signer across different clients.
 *
 * @param params
 */
export declare function createDeterministicLinkedSignerPrivateKey(params: Params): Promise<`0x${string}`>;
export {};
//# sourceMappingURL=createDeterministicLinkedSignerPrivateKey.d.ts.map