import { BigDecimalish } from '@vertex-protocol/utils';
export type OrderExpirationType = 'default' | 'ioc' | 'fok' | 'post_only';
export interface OrderExpirationConfig {
    type: OrderExpirationType;
    expirationTime: number;
    reduceOnly?: boolean;
}
/**
 * Special order types, such as immediate-or-cancel, are encoded into the expiration field.
 * This is a utility to create the proper timestamp needed
 *
 * @param config
 */
export declare function getExpirationTimestamp(config: OrderExpirationConfig): bigint;
/**
 * Parses the expiration timestamp into its subcomponents:
 * - expiration type
 * - expiration timestamp in UNIX seconds
 * - value of the reduce only flag
 *
 * @param rawExpiration
 */
export declare function parseRawExpirationTimestamp(rawExpiration: BigDecimalish): Required<OrderExpirationConfig>;
//# sourceMappingURL=orderExpiration.d.ts.map