/**
 * Generates an order nonce based on recvTime in milliseconds, defaulting to Date.now() + 90 seconds
 * @param recvTimeMillis
 * @param randomInt a random integer to avoid hash collisions
 */
export declare function getOrderNonce(recvTimeMillis?: number, randomInt?: number): string;
/**
 * Generates a trigger order nonce based on recvTime in milliseconds, defaulting to Date.now() + 90 seconds
 * Trigger order nonces require that the first bit is set to 1, this differentiates it from a regular order nonce
 *
 * @param recvTimeMillis
 * @param randomInt
 */
export declare function getTriggerOrderNonce(recvTimeMillis?: number, randomInt?: number): string;
/**
 * Determines if a nonce is a trigger order nonce
 */
export declare function isTriggerOrderNonce(orderNonce: string): boolean;
/**
 * Gets the recvTime in millis from an order nonce
 *
 * @param orderNonce
 */
export declare function getRecvTimeFromOrderNonce(orderNonce: string): number;
//# sourceMappingURL=orderNonce.d.ts.map